int[] idL;
import java.awt.Font;

public void handleButtonEvents(GButton button, GEvent event) {
  if (event == GEvent.CLICKED) {

    if (idL != null) {
      for (int i=0; i<idL.length; i++) {
        labels[i].setVisible(false);
        txfLiens[i].setVisible(false);
      }
    }
    if (txfNom != null) txfNom.setVisible(false);
    if (labels[0] != null) labels[0].setVisible(false);

    if (button == btnNewArbo) {
      arbo.nouveau();
      updateAffArbo = true;
    }

    if (button == btnLoadArbo) {
      selectInput("Choisir arborescence à charger:", "arboSelected");
    }

    if (button == btnSaveArbo) {
      selectFolder("Choisir le dossier où enregistrer arborescence.json:", "arboSauv");
    }

    if (button == btnCreerFille) {
      if (pSelect != null) {
        labels[0] = new GLabel(this, 10, 550-25, 190, 30);
        labels[0].setFont(new Font("Futura", Font.BOLD, 18));
        labels[0].setLocalColor(2, color(255, 0, 0));
        labels[0].setText("Entrer nom fille");
        txfNom = new GTextField(this, 10, 550, 180, 30);
        txfNom.setFont(new Font("Futura", Font.BOLD, 18));
        txfNom.setPromptText("entrer nom page");
        txfNom.tag = "txfNom";
        txfNom.setFocus(true);
      }
    }

    if (button == btnSupprimerPage) {
      if (pSelect != null) {
        if (arbo.supprimerPage(pSelect)) {
          updateAffArbo = true;
        }
      }
    }

    if (button == btnCreerLien) {
      lSource = pSelect.id;
      lSupp = false;
    }

    if (button == btnEditerLien) {
      int[] idPf = pSelect.getIdPagesFilles();
      idL = pSelect.getIdLiens();
      for (int i=0; i<idL.length; i++) {
        int j = i/6;
        labels[i] = new GLabel(this, 10 + 200*j, 550+(i%6)*60-25, 180, 30);
        labels[i].setFont(new Font("Futura", Font.BOLD, 18));
        labels[i].setLocalColor(2, color(255, 0, 0));
        labels[i].setText(arbo.page[idPf[i]].getNom());
        
        txfLiens[i] = new GTextField(this, 10 + 200*j, 550+(i%6)*60, 180, 30);
        txfLiens[i].setFont(new Font("Futura", Font.BOLD, 18));
        txfLiens[i].setText(arbo.lien[idL[i]].clavier);
        txfLiens[i].tag = "txfLiens"+nf(i, 3, 0);
        txfLiens[0].setFocus(true);
      }
    }

    if (button == btnSupprimerLien) {
      lSource = pSelect.id;
      lSupp = true;
    }

    if (button == btnEcho) {
      if (pSelect != null) {
        pSelect.setEcho(!pSelect.getEcho());
        if (pSelect.getEcho()) {
          btnEcho.setText("echo off");
        } else btnEcho.setText("echo on");
      }
    }
  }
}

public void handleTextEvents(GEditableTextControl textControl, GEvent event) { 
  displayEvent(textControl.tag, event);
}

public void displayEvent(String name, GEvent event) {
  switch(event) {
  case CHANGED:

    break;
  case SELECTION_CHANGED:

    break;
  case LOST_FOCUS:
    break;
  case GETS_FOCUS:
    break;
  case ENTERED:
    if (name.equals("txfNom")) {
      arbo.addPage(txfNom.getText(), pSelect.nom);
      txfNom.setFocus(false);
      labels[0].setVisible(false);
      txfNom.setVisible(false);
    }
    String debut = name.substring(0, name.length()-3);
    if (debut.equals("txfLiens")) {
      int i = int(name.substring(name.length()-3));
      arbo.editLien(idL[i], txfLiens[i].getText());
      for (int iL=0; iL<idL.length; iL++) {
        txfLiens[iL].setFocus(false);
        txfLiens[iL].setVisible(false);
        labels[iL].setVisible(false);
      }
      //arbo = new Arbo("temp.json");
      //arbo.affArbo();
    }
    break;
  default:
    println("UNKNOWN ");
  }
}

void initMenu() {
  affWidth = width-lMenu;
  G4P.setGlobalColorScheme(5);
  btnNewArbo = new GButton(this, 10, 10, 180, 40, "Nouvelle");
  btnNewArbo.setFont(new Font("Futura", Font.BOLD, 24));
  btnNewArbo.tag = "Nouvelle";

  btnLoadArbo = new GButton(this, 10, 60, 180, 40, "Ouvrir");
  btnLoadArbo.setFont(new Font("Futura", Font.BOLD, 24));
  btnLoadArbo.tag = "Ouvrir";

  btnSaveArbo = new GButton(this, 10, 110, 180, 40, "Enregistrer");
  btnSaveArbo.setFont(new Font("Futura", Font.BOLD, 24));
  btnSaveArbo.tag = "Enregistrer";

  btnCreerFille = new GButton(this, 10, 180, 180, 40, "Creer Fille");
  btnCreerFille.setFont(new Font("Futura", Font.BOLD, 24));
  btnCreerFille.tag = "Créer Fille";

  btnSupprimerPage = new GButton(this, 10, 230, 180, 40, "Supp Page");
  btnSupprimerPage.setFont(new Font("Futura", Font.BOLD, 24));
  btnSupprimerPage.tag = "Supp Page";

  btnCreerLien = new GButton(this, 10, 300, 180, 40, "Creer Lien");
  btnCreerLien.setFont(new Font("Futura", Font.BOLD, 24));
  btnCreerLien.tag = "Créer Lien";

  btnEditerLien = new GButton(this, 10, 350, 180, 40, "Editer Lien");
  btnEditerLien.setFont(new Font("Futura", Font.BOLD, 24));
  btnEditerLien.tag = "Editer Lien";

  btnSupprimerLien = new GButton(this, 10, 400, 180, 40, "Supp Lien");
  btnSupprimerLien.setFont(new Font("Futura", Font.BOLD, 24));
  btnSupprimerLien.tag = "Supp Lien";

  labelMsg = new GLabel(this, 10, height-50, width - lMenu, 50);
  labelMsg.setFont(new Font("Futura", Font.BOLD, 24));
  labelMsg.setLocalColor(2, color(255, 0, 0));
  labelMsg.setText("");
  labelMsg.setVisible(false);

  btnEcho = new GButton(this, 10, 480, 180, 40, "Echo");
  btnEcho.setFont(new Font("Futura", Font.BOLD, 24));
  btnEcho.tag = "Echo";
}
