class Lien {
  int id = 0;
  int source = 0;
  int destination = 0;
  int xS, yS, xD, yD;
  color couleur;
  String clavier;
  boolean retour;

  Lien(int _source, int _destination, String _clavier) {
    source = _source;
    destination = _destination;
    clavier = _clavier;
    retour = false;
  }

  void textAff() {
    stroke(couleur);
    fill(couleur);
    line(xS, yS, xD, yD);
    
      pushMatrix();
      if(retour){
        translate((xS+xD)/2, (yS+yD)/2-8);
      }
      else{
        translate((xS+xD)/2, (yS+yD)/2+8);
      }
      float angle = atan2(yS-yD, (xS-xD));
      if (angle<-PI/2 || angle>PI/2) angle+=PI;
      rotate(angle);
      text(clavier, 0, 0);
      popMatrix();
  }
}
